# GNU Enterprise Application Server - Instance Object
#
# Copyright 2001 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: geasInstance.py,v 1.7 2002/07/03 21:33:55 siesel Exp $

# =============================================================================
# Instance class
# =============================================================================

class geasInstance:

  # ---------------------------------------------------------------------------
  # Initalize
  # ---------------------------------------------------------------------------

  def __init__ (self, list, record):
    self._list = list
    self._record = record

  # ---------------------------------------------------------------------------
  # Get the value of a field
  # ---------------------------------------------------------------------------

  def get (self, fieldname):
    # TODO: look up the field type (calculated, reference etc.), translate
    # the field name into a column name
    return self._record.getField (fieldname)

  # ---------------------------------------------------------------------------
  # Set the value of a field
  # ---------------------------------------------------------------------------

  def put (self, fieldname, value):
    # TODO: translate the field name into a column name
    self._record.setField (fieldname, value)

  # ---------------------------------------------------------------------------
  # Call a method
  # ---------------------------------------------------------------------------

  def call (self, methodname, params):
    # not yet implemented
    
    # mis-using trigger to implement methods
    trigger=self._list._session._triggerMg.getTriggerByName \
               ('%s:%s' % (self._list._classname,methodname))
    if trigger!=None:
        return trigger()
    # just containing a basic test method
    if methodname=="show":
      print "Function 'show' was called. This record contains the following "+\
            " values:"
      for i in self._record._fields.keys():
        print "%s : %s " % (i,self._record._fields[i])
      print
    else:
      print "The method %s is not implemented." % methodname

  # ---------------------------------------------------------------------------
  # Delete this instance 
  # ---------------------------------------------------------------------------

  def delete(self):
    self._record.delete()
