# GNU Enterprise Application Server - RPC client 
#
# Copyright 2001 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# $Id: geasRpcClient.py,v 1.3 2002/05/06 22:32:59 siesel Exp $



from gnue.common import GComm

# =============================================================================
# RPC client class
# =============================================================================


class geasRpcClient:
  def __init__(self,interface,params):
    self._interface=interface
    self._params=params    
    self._server = GComm.attach(self._interface, self._params)  
  

  def requestSessionManager(self):
    
    sessionManager = self._server.request("SessionManager")    

    return sessionManager
  
  

# Example: 
#   params = { 'host': 'localhost',
#              'port': 8765,
#              'transport': 'http' }
#   rpcClient = geasRpcClient('xmlrpc',params)
#   sessMan = requestSessionManager()
#   print sessMan.Status

#
#  The RPC test
#

import test 
class rpcTestApp(test.testApp):

  def getSession(self):
    print "Opening RPC connection ..."
    params = { 'host': 'localhost',
               'port': 8765,
               'transport': 'http' }
    rpcClient = geasRpcClient('xmlrpc',params)

    
    print "Setup an link to the session manager"
    sessionManager = rpcClient.requestSessionManager()
    
    print "Get the status of the session manager"
    print "Status: ",sessionManager.Status()
    
    print "Creating session object ..."  
    return sessionManager.getNewSession()    

def run():
  rpcTestApp().run()

if __name__ == "__main__":
  run()
