# GNU Enterprise Application Server - Business object class definitions 
#
# Copyright 2001 Free Software Foundation
#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it 
# and/or modify it under the terms of the GNU General Public 
# License as published by the Free Software Foundation; either 
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied 
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public 
# License along with program; see the file COPYING. If not, 
# write to the Free Software Foundation, Inc., 59 Temple Place 
# - Suite 330, Boston, MA 02111-1307, USA.
#
# FILE:
#
# GClassDefs.py
# 
# DESCRIPTION:
# 
# Defines types for holding the definition of business objects and their
# members (fields, methods, hooks, trigger methods etc.) This file is
# part of the GEOR module of GEAS.

from gnue.common import GParser
from gnue.common.FileUtils import openResource


###################################################
# Object definition class
###################################################

class GObjectDef:
    def __init__(self, definition):
        self.fields = {} # field name, field def object
        self.methods = {} # method name, method def object
        # hm ... need to signify the difference between class and instance
        # methods here
        
        self.hooks = {} # hook name, hook def object
        # the functions registered by other objects with our hooks
        # are stored in the hook def object
        
        self.registeredMethods = [] # store registration definitons here

        

    # TODO: some more methods. please add ideas
    #    -
    #    -
    #    -
    # Add init methods to initialize from XML and Database. Help for XML is appreciated.
    # Probably we should use the methods provided in common.



# GFieldDefinition is the definition of an specific field in an object.
    
class GFieldDefinition:
    def __init__(self,name,type,length):
        self.name=name

        #check if type is of type GTypeDefinition
        self.type=type
        self.length=length

# GTypeDefinition is the definition of an abstract type.
# Types are the basis for field definitions.

class GTypeDefinition:
    def __init__(self):
        pass


class GBaseTypeDefinition:
    def __init__(self):
        pass


class GCompoundTypeDefinition:
    def __init__(self):
        pass

class GPointerTypeDefinition:
    def __init__(self):
        pass

# TODO: specify interfaces of the above classes
#       clear how lists should be implemented
